From f9269410afbd111a7fa32b53a4402d773530e1f8 Mon Sep 17 00:00:00 2001
From: Jan Zeleny <jzeleny@redhat.com>
Date: Fri, 15 Apr 2011 12:57:04 -0400
Subject: [PATCH 2/2] Man page for sss_cache

---
 src/man/Makefile.am     |    2 +-
 src/man/sss_cache.8.xml |  122 +++++++++++++++++++++++++++++++++++++++++++++++
 2 files changed, 123 insertions(+), 1 deletions(-)
 create mode 100644 src/man/sss_cache.8.xml

diff --git a/src/man/Makefile.am b/src/man/Makefile.am
index f84cc2f461f083914e8431e7e779bc12949b357d..24acb06f470a326aeeac000eb965e3c53b2020d2 100644
--- a/src/man/Makefile.am
+++ b/src/man/Makefile.am
@@ -17,7 +17,7 @@ man_MANS = \
     sssd.8 sssd.conf.5 sssd-ldap.5 \
     sssd-krb5.5 sssd-ipa.5 sssd-simple.5 \
     sssd_krb5_locator_plugin.8 sss_groupshow.8 \
-    pam_sss.8 sss_obfuscate.8
+    pam_sss.8 sss_obfuscate.8 sss_cache.8
 EXTRA_DIST = $(man_MANS:%=%.xml) $(wildcard $(srcdir)/include/*.xml)
 
 SUFFIXES = .1.xml .1 .3.xml .3 .5.xml .5 .8.xml .8
diff --git a/src/man/sss_cache.8.xml b/src/man/sss_cache.8.xml
new file mode 100644
index 0000000000000000000000000000000000000000..f30d00d6c808ea2f866c2f2225079027b1e15c6c
--- /dev/null
+++ b/src/man/sss_cache.8.xml
@@ -0,0 +1,122 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<!DOCTYPE reference PUBLIC "-//OASIS//DTD DocBook V4.4//EN"
+"http://www.oasis-open.org/docbook/xml/4.4/docbookx.dtd">
+<reference>
+<title>SSSD Manual pages</title>
+<refentry>
+    <xi:include xmlns:xi="http://www.w3.org/2001/XInclude" href="include/upstream.xml" />
+
+    <refmeta>
+        <refentrytitle>sss_cache</refentrytitle>
+        <manvolnum>8</manvolnum>
+    </refmeta>
+
+    <refnamediv id='name'>
+        <refname>sss_cache</refname>
+        <refpurpose>perform cache cleanup</refpurpose>
+    </refnamediv>
+
+    <refsynopsisdiv id='synopsis'>
+        <cmdsynopsis>
+            <command>sss_cache</command>
+            <arg choice='opt'>
+                <replaceable>options</replaceable>
+            </arg>
+        </cmdsynopsis>
+    </refsynopsisdiv>
+
+    <refsect1 id='description'>
+        <title>DESCRIPTION</title>
+        <para>
+            <command>sss_cache</command> invalidates records in SSSD cache.
+            Invalidated records are forced to be reloaded from server as soon
+            as related SSSD backend is online.
+        </para>
+    </refsect1>
+
+    <refsect1 id='options'>
+        <title>OPTIONS</title>
+        <variablelist remap='IP'>
+            <varlistentry>
+                <term>
+                    <option>-u</option>,<option>--user</option>
+                    <replaceable>login</replaceable>
+                </term>
+                <listitem>
+                    <para>
+                        Invalidate specific user.
+                    </para>
+                </listitem>
+            </varlistentry>
+            <varlistentry>
+                <term>
+                    <option>-U</option>,<option>--users</option>
+                </term>
+                <listitem>
+                    <para>
+                        Invalidate all user records. This option overrides
+                        invalidation of specific user if it was also set.
+                    </para>
+                </listitem>
+            </varlistentry>
+            <varlistentry>
+                <term>
+                    <option>-g</option>,<option>--group</option>
+                    <replaceable>group</replaceable>
+                </term>
+                <listitem>
+                    <para>
+                        Invalidate specific group.
+                    </para>
+                </listitem>
+            </varlistentry>
+            <varlistentry>
+                <term>
+                    <option>-G</option>,<option>--groups</option>
+                </term>
+                <listitem>
+                    <para>
+                        Invalidate all group records. This option overrides
+                        invalidation of specific group if it was also set.
+                    </para>
+                </listitem>
+            </varlistentry>
+            <varlistentry>
+                <term>
+                    <option>-n</option>,<option>--netgroup</option>
+                    <replaceable>netgroup</replaceable>
+                </term>
+                <listitem>
+                    <para>
+                        Invalidate specific netgroup.
+                    </para>
+                </listitem>
+            </varlistentry>
+            <varlistentry>
+                <term>
+                    <option>-N</option>,<option>--netgroups</option>
+                </term>
+                <listitem>
+                    <para>
+                        Invalidate all netgroup records. This option overrides
+                        invalidation of specific netgroup if it was also set.
+                    </para>
+                </listitem>
+            </varlistentry>
+            <varlistentry>
+                <term>
+                    <option>-d</option>,<option>--domain</option>
+                    <replaceable>domain</replaceable>
+                </term>
+                <listitem>
+                    <para>
+                        Restrict invalidation process only to a particular
+                        domain.
+                    </para>
+                </listitem>
+            </varlistentry>
+            <xi:include xmlns:xi="http://www.w3.org/2001/XInclude" href="include/param_help.xml" />
+        </variablelist>
+    </refsect1>
+</refentry>
+</reference>
-- 
1.7.4.1